# Shared File Systems service (manila) command-line client

The manila client is the command-line interface (CLI) for the Shared File Systems service (manila) API and its extensions.

This chapter documents manila version `1.16.0`.

For help on a specific manila command, enter:

    $ manila help COMMAND

## manila usage

    usage: manila [--version] [-d] [--os-cache] [--os-reset-cache]
                  [--os-user-id <auth-user-id>] [--os-username <auth-user-name>]
                  [--os-password <auth-password>]
                  [--os-tenant-name <auth-tenant-name>]
                  [--os-project-name <auth-project-name>]
                  [--os-tenant-id <auth-tenant-id>]
                  [--os-project-id <auth-project-id>]
                  [--os-user-domain-id <auth-user-domain-id>]
                  [--os-user-domain-name <auth-user-domain-name>]
                  [--os-project-domain-id <auth-project-domain-id>]
                  [--os-project-domain-name <auth-project-domain-name>]
                  [--os-auth-url <auth-url>] [--os-region-name <region-name>]
                  [--os-token <token>] [--bypass-url <bypass-url>]
                  [--service-type <service-type>] [--service-name <service-name>]
                  [--share-service-name <share-service-name>]
                  [--endpoint-type <endpoint-type>]
                  [--os-share-api-version <share-api-ver>]
                  [--os-cacert <ca-certificate>] [--retries <retries>]
                  [--os-cert <certificate>]
                  <subcommand> ...

Subcommands:

`absolute-limits`

  Print a list of absolute limits for a user.

`access-allow`

  Allow access to the share.

`access-deny`

  Deny access to a share.

`access-list`

  Show access list for share.

`api-version`

  Display the API version information.

`availability-zone-list`

  List all availability zones.

`create`

  Creates a new share (NFS, CIFS, CephFS, GlusterFS or HDFS).

`credentials`

  Show user credentials returned from auth.

`delete`

  Remove one or more shares.

`endpoints`

  Discover endpoints that get returned from the authenticate services.

`extend`

  Increases the size of an existing share.

`extra-specs-list`

  Print a list of current ‘share types and extra specs’ (Admin Only).

`force-delete`

  Attempt force-delete of share, regardless of state (Admin only).

`list`

  List NAS shares with filters.

`manage`

  Manage share not handled by Manila (Admin only).

`message-delete`

  Remove one or more messages.

`message-list`

  Lists all messages.

`message-show`

  Show message’s details.

`metadata`

  Set or delete metadata on a share.

`metadata-show`

  Show metadata of given share.

`metadata-update-all`

  Update all metadata of a share.

`migration-cancel`

  Cancels migration of a given share when copying (Admin only, Experimental).

`migration-complete`

  Completes migration for a given share (Admin only, Experimental).

`migration-get-progress`

  Gets migration progress of a given share when copying (Admin only, Experimental).

`migration-start`

  Migrates share to a new host (Admin only, Experimental).

`pool-list`

  List all backend storage pools known to the scheduler (Admin only).

`quota-class-show`

  List the quotas for a quota class.

`quota-class-update`

  Update the quotas for a quota class (Admin only).

`quota-defaults`

  List the default quotas for a tenant.

`quota-delete`

  Delete quota for a tenant/user. The quota will revert back to default (Admin only).

`quota-show`

  List the quotas for a tenant/user.

`quota-update`

  Update the quotas for a tenant/user (Admin only).

`rate-limits`

  Print a list of rate limits for a user.

`reset-state`

  Explicitly update the state of a share (Admin only).

`reset-task-state`

  Explicitly update the task state of a share (Admin only, Experimental).

`revert-to-snapshot`

  Revert a share to the specified snapshot.

`security-service-create`

  Create security service used by tenant.

`security-service-delete`

  Delete one or more security services.

`security-service-list`

  Get a list of security services.

`security-service-show`

  Show security service.

`security-service-update`

  Update security service.

`service-disable`

  Disables ‘manila-share’ or ‘manila-scheduler’ services (Admin only).

`service-enable`

  Enables ‘manila-share’ or ‘manila-scheduler’ services (Admin only).

`service-list`

  List all services (Admin only).

`share-export-location-list`

  List export locations of a given share.

`share-export-location-show`

  Show export location of the share.

`share-group-create`

  Creates a new share group (Experimental).

`share-group-delete`

  Remove one or more share groups (Experimental).

`share-group-list`

  List share groups with filters (Experimental).

`share-group-reset-state`

  Explicitly update the state of a share group (Admin only, Experimental).

`share-group-show`

  Show details about a share group (Experimental).

`share-group-snapshot-create`

  Creates a new share group snapshot (Experimental).

`share-group-snapshot-delete`

  Remove one or more share group snapshots (Experimental).

`share-group-snapshot-list`

  List share group snapshots with filters (Experimental).

`share-group-snapshot-list-members`

  List members of a share group snapshot (Experimental).

`share-group-snapshot-reset-state`

  Explicitly update the state of a share group snapshot (Admin only, Experimental).

`share-group-snapshot-show`

  Show details about a share group snapshot (Experimental).

`share-group-snapshot-update`

  Update a share group snapshot (Experimental).

`share-group-type-access-add`

  Adds share group type access for the given project (Admin only).

`share-group-type-access-list`

  Print access information about a share group type (Admin only).

`share-group-type-access-remove`

  Removes share group type access for the given project (Admin only).

`share-group-type-create`

  Create a new share group type (Admin only).

`share-group-type-delete`

  Delete a specific share group type (Admin only).

`share-group-type-key`

  Set or unset group_spec for a share group type (Admin only).

`share-group-type-list`

  Print a list of available ‘share group types’.

`share-group-type-specs-list`

  Print a list of ‘share group types specs’ (Admin Only).

`share-group-update`

  Update a share group (Experimental).

`share-instance-export-location-list`

  List export locations of a given share instance.

`share-instance-export-location-show`

  Show export location for the share instance.

`share-instance-force-delete`

  Force-delete the share instance, regardless of state (Admin only).

`share-instance-list`

  List share instances (Admin only).

`share-instance-reset-state`

  Explicitly update the state of a share instance (Admin only).

`share-instance-show`

  Show details about a share instance (Admin only).

`share-network-create`

  Create description for network used by the tenant.

`share-network-delete`

  Delete one or more share networks.

`share-network-list`

  Get a list of network info.

`share-network-security-service-add`

  Associate security service with share network.

`share-network-security-service-list`

  Get list of security services associated with a given share network.

`share-network-security-service-remove`

  Dissociate security service from share network.

`share-network-show`

  Get a description for network used by the tenant.

`share-network-update`

  Update share network data.

`share-replica-create`

  Create a share replica (Experimental).

`share-replica-delete`

  Remove one or more share replicas (Experimental).

`share-replica-list`

  List share replicas (Experimental).

`share-replica-promote`

  Promote specified replica to ‘active’ replica_state (Experimental).

`share-replica-reset-replica-state`

  Explicitly update the ‘replica_state’ of a share replica (Experimental).

`share-replica-reset-state`

  Explicitly update the ‘status’ of a share replica (Experimental).

`share-replica-resync`

  Attempt to update the share replica with its ‘active’ mirror (Experimental).

`share-replica-show`

  Show details about a replica (Experimental).

`share-server-delete`

  Delete one or more share servers (Admin only).

`share-server-details`

  Show share server details (Admin only).

`share-server-list`

  List all share servers (Admin only).

`share-server-show`

  Show share server info (Admin only).

`show`

  Show details about a NAS share.

`shrink`

  Decreases the size of an existing share.

`snapshot-access-allow`

  Allow read only access to a snapshot.

`snapshot-access-deny`

  Deny access to a snapshot.

`snapshot-access-list`

  Show access list for a snapshot.

`snapshot-create`

  Add a new snapshot.

`snapshot-delete`

  Remove one or more snapshots.

`snapshot-export-location-list`

  List export locations of a given snapshot.

`snapshot-export-location-show`

  Show export location of the share snapshot.

`snapshot-force-delete`

  Attempt force-deletion of one or more snapshots. Regardless of the state (Admin only).

`snapshot-instance-export-location-list`

  List export locations of a given snapshot instance.

`snapshot-instance-export-location-show`

  Show export location of the share instance snapshot.

`snapshot-instance-list`

  List share snapshot instances.

`snapshot-instance-reset-state`

  Explicitly update the state of a share snapshot instance.

`snapshot-instance-show`

  Show details about a share snapshot instance.

`snapshot-list`

  List all the snapshots.

`snapshot-manage`

  Manage share snapshot not handled by Manila (Admin only).

`snapshot-rename`

  Rename a snapshot.

`snapshot-reset-state`

  Explicitly update the state of a snapshot (Admin only).

`snapshot-show`

  Show details about a snapshot.

`snapshot-unmanage`

  Unmanage one or more share snapshots (Admin only).

`type-access-add`

  Adds share type access for the given project (Admin only).

`type-access-list`

  Print access information about the given share type (Admin only).

`type-access-remove`

  Removes share type access for the given project (Admin only).

`type-create`

  Create a new share type (Admin only).

`type-delete`

  Delete one or more specific share types (Admin only).

`type-key`

  Set or unset extra_spec for a share type (Admin only).

`type-list`

  Print a list of available ‘share types’.

`unmanage`

  Unmanage share (Admin only).

`update`

  Rename a share.

`bash-completion`

  Print arguments for bash_completion. Prints all of the commands and options to stdout so that the manila.bash_completion script doesn’t have to hard code them.

`help`

  Display help about this program or one of its subcommands.

`list-extensions`

  List all the os-api extensions that are available.

## manila optional arguments

`--version`

  show program’s version number and exit

`-d, --debug`

  Print debugging output.

`--os-cache`

  Use the auth token cache. Defaults to `env[OS_CACHE]`.

`--os-reset-cache`

  Delete cached password and auth token.

`--os-user-id <auth-user-id>`

  Defaults to env [OS_USER_ID].

`--os-username <auth-user-name>`

  Defaults to `env[OS_USERNAME]`.

`--os-password <auth-password>`

  Defaults to `env[OS_PASSWORD]`.

`--os-tenant-name <auth-tenant-name>`

  Defaults to `env[OS_TENANT_NAME]`.

`--os-project-name <auth-project-name>`

  Another way to specify tenant name. This option is mutually exclusive with –os-tenant-name. Defaults to `env[OS_PROJECT_NAME]`.

`--os-tenant-id <auth-tenant-id>`

  Defaults to `env[OS_TENANT_ID]`.

`--os-project-id <auth-project-id>`

  Another way to specify tenant ID. This option is mutually exclusive with –os-tenant-id. Defaults to `env[OS_PROJECT_ID]`.

`--os-user-domain-id <auth-user-domain-id>`

  OpenStack user domain ID. Defaults to `env[OS_USER_DOMAIN_ID]`.

`--os-user-domain-name <auth-user-domain-name>`

  OpenStack user domain name. Defaults to `env[OS_USER_DOMAIN_NAME]`.

`--os-project-domain-id <auth-project-domain-id>`

  Defaults to `env[OS_PROJECT_DOMAIN_ID]`.

`--os-project-domain-name <auth-project-domain-name>`

  Defaults to `env[OS_PROJECT_DOMAIN_NAME]`.

`--os-auth-url <auth-url>`

  Defaults to `env[OS_AUTH_URL]`.

`--os-region-name <region-name>`

  Defaults to `env[OS_REGION_NAME]`.

`--os-token <token>`

  Defaults to `env[OS_TOKEN]`.

`--bypass-url <bypass-url>`

  Use this API endpoint instead of the Service Catalog. Defaults to `env[OS_MANILA_BYPASS_URL]`.

`--service-type <service-type>`

  Defaults to compute for most actions.

`--service-name <service-name>`

  Defaults to `env[OS_MANILA_SERVICE_NAME]`.

`--share-service-name <share-service-name>`

  Defaults to `env[OS_MANILA_SHARE_SERVICE_NAME]`.

`--endpoint-type <endpoint-type>`

  Defaults to `env[OS_MANILA_ENDPOINT_TYPE]` or publicURL.

`--os-share-api-version <share-api-ver>`

  Accepts 1.x to override default to `env[OS_SHARE_API_VERSION]`.

`--os-cacert <ca-certificate>`

  Specify a CA bundle file to use in verifying a TLS (https) server certificate. Defaults to `env[OS_CACERT]`.

`--retries <retries>`

  Number of retries.

`--os-cert <certificate>`

  Defaults to `env[OS_CERT]`.

### manila absolute-limits

    usage: manila absolute-limits

Print a list of absolute limits for a user.

### manila access-allow

    usage: manila access-allow [--access-level <access_level>]
                               <share> <access_type> <access_to>

Allow access to the share.

Positional arguments:

`<share>`

  Name or ID of the NAS share to modify.

`<access_type>`

  Access rule type (only “ip”, “user”(user or group), “cert” or “cephx” are supported).

`<access_to>`

  Value that defines access.

Optional arguments:

`--access-level <access_level>, --access_level <access_level>`

  Share access level (“rw” and “ro” access levels are supported). Defaults to rw.

### manila access-deny

    usage: manila access-deny <share> <id>

Deny access to a share.

Positional arguments:

`<share>`

  Name or ID of the NAS share to modify.

`<id>`

  ID of the access rule to be deleted.

### manila access-list

    usage: manila access-list [--columns <columns>] <share>

Show access list for share.

Positional arguments:

`<share>`

  Name or ID of the share.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “access_type,access_to”.

### manila api-version

    usage: manila api-version

Display the API version information.

### manila availability-zone-list

    usage: manila availability-zone-list [--columns <columns>]

List all availability zones.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila create

    usage: manila create [--snapshot-id <snapshot-id>] [--name <name>]
                         [--metadata [<key=value> [<key=value> ...]]]
                         [--share-network <network-info>]
                         [--description <description>] [--share-type <share-type>]
                         [--public] [--availability-zone <availability-zone>]
                         [--share-group <share-group>]
                         <share_protocol> <size>

Creates a new share (NFS, CIFS, CephFS, GlusterFS or HDFS).

Positional arguments:

`<share_protocol>`

  Share protocol (NFS, CIFS, CephFS, GlusterFS or HDFS).

`<size>`

  Share size in GiB.

Optional arguments:

`--snapshot-id <snapshot-id>, --snapshot_id <snapshot-id>`

  Optional snapshot ID to create the share from. (Default=None)

`--name <name>`

  Optional share name. (Default=None)

`--metadata [<key=value> [<key=value> ...]]`

  Metadata key=value pairs (Optional, Default=None).

`--share-network <network-info>, --share_network <network-info>`

  Optional network info ID or name.

`--description <description>`

  Optional share description. (Default=None)

`--share-type <share-type>, --share_type <share-type>, --volume-type <share-type>, --volume_type <share-type>`

  Optional share type. Use of optional volume type is deprecated. (Default=None)

`--public`

  Level of visibility for share. Defines whether other tenants are able to see it or not.

`--availability-zone <availability-zone>, --availability_zone <availability-zone>, --az <availability-zone>`

  Availability zone in which share should be created.

`--share-group <share-group>, --share_group <share-group>, --group <share-group>`

  Optional share group name or ID in which to create the share (Experimental, Default=None).

### manila credentials

    usage: manila credentials

Show user credentials returned from auth.

### manila delete

    usage: manila delete [--share-group <share-group>] <share> [<share> ...]

Remove one or more shares.

Positional arguments:

`<share>`

  Name or ID of the share(s).

Optional arguments:

`--share-group <share-group>, --share_group <share-group>, --group <share-group>`

  Optional share group name or ID which contains the share (Experimental, Default=None).

### manila endpoints

    usage: manila endpoints

Discover endpoints that get returned from the authenticate services.

### manila extend

    usage: manila extend [--wait] [--force] <share> <new_size>

Increases the size of an existing share.

Positional arguments:

`<share>`

  Name or ID of share to extend.

`<new_size>`

  New size of share, in GiBs.

Optional arguments:

`--wait`

  Wait for share extension.

`--force`

  Extend share directly and not go through scheduler.

### manila extra-specs-list

    usage: manila extra-specs-list [--columns <columns>]

Print a list of current ‘share types and extra specs’ (Admin Only).

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila force-delete

    usage: manila force-delete <share> [<share> ...]

Attempt force-delete of share, regardless of state (Admin only).

Positional arguments:

`<share>`

  Name or ID of the share(s) to force delete.

### manila list

    usage: manila list [--all-tenants [<0|1>]] [--name <name>] [--status <status>]
                       [--share-server-id <share_server_id>]
                       [--metadata [<key=value> [<key=value> ...]]]
                       [--extra-specs [<key=value> [<key=value> ...]]]
                       [--share-type <share_type>] [--limit <limit>]
                       [--offset <offset>] [--sort-key <sort_key>]
                       [--sort-dir <sort_dir>] [--snapshot <snapshot>]
                       [--host <host>] [--share-network <share_network>]
                       [--project-id <project_id>] [--public]
                       [--share-group <share_group>] [--columns <columns>]

List NAS shares with filters.

Optional arguments:

`--all-tenants [<0|1>]`

  Display information from all tenants (Admin only).

`--name <name>`

  Filter results by name.

`--status <status>`

  Filter results by status.

`--share-server-id <share_server_id>, --share-server_id <share_server_id>, --share_server-id <share_server_id>, --share_server_id <share_server_id>`

  Filter results by share server ID (Admin only).

`--metadata [<key=value> [<key=value> ...]]`

  Filters results by a metadata key and value. OPTIONAL: Default=None.

`--extra-specs [<key=value> [<key=value> ...]], --extra_specs [<key=value> [<key=value> ...]]`

  Filters results by an extra specs key and value of share type that was used for share creation. OPTIONAL: Default=None.

`--share-type <share_type>, --volume-type <share_type>, --share_type <share_type>, --share-type-id <share_type>, --volume-type-id <share_type>, --share-type_id <share_type>, --share_type-id <share_type>, --share_type_id <share_type>, --volume_type <share_type>, --volume_type_id <share_type>`

  Filter results by a share type id or name that was used for share creation.

`--limit <limit>`

  Maximum number of shares to return. OPTIONAL: Default=None.

`--offset <offset>`

  Set offset to define start point of share listing. OPTIONAL: Default=None.

`--sort-key <sort_key>, --sort_key <sort_key>`

  Key to be sorted, available keys are (‘id’, ‘status’, ‘size’, ‘host’, ‘share_proto’, ‘availability_zone’, ‘user_id’, ‘project_id’, ‘created_at’, ‘updated_at’, ‘display_name’, ‘name’, ‘share_type_id’, ‘share_type’, ‘share_network_id’, ‘share_network’, ‘snapshot_id’, ‘snapshot’). OPTIONAL: Default=None.

`--sort-dir <sort_dir>, --sort_dir <sort_dir>`

  Sort direction, available values are (‘asc’, ‘desc’). OPTIONAL: Default=None.

`--snapshot <snapshot>`

  Filter results by snapshot name or id, that was used for share.

`--host <host>`

  Filter results by host.

`--share-network <share_network>, --share_network <share_network>`

  Filter results by share-network name or id.

`--project-id <project_id>, --project_id <project_id>`

  Filter results by project id. Useful with set key ‘–all-tenants’.

`--public`

  Add public shares from all tenants to result.

`--share-group <share_group>, --share_group <share_group>, --group <share_group>`

  Filter results by share group name or ID (Experimental, Default=None).

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “export_location,is public”.

### manila list-extensions

    usage: manila list-extensions

List all the os-api extensions that are available.

### manila manage

    usage: manila manage [--name <name>] [--description <description>]
                         [--share_type <share-type>]
                         [--driver_options [<key=value> [<key=value> ...]]]
                         [--public]
                         <service_host> <protocol> <export_path>

Manage share not handled by Manila (Admin only).

Positional arguments:

`<service_host>`

  manage-share service host: some.host@driver#pool.

`<protocol>`

  Protocol of the share to manage, such as NFS or CIFS.

`<export_path>`

  Share export path, NFS share such as: 10.0.0.1:/example_path, CIFS share such as: \\10.0.0.1\example_cifs_share.

Optional arguments:

`--name <name>`

  Optional share name. (Default=None)

`--description <description>`

  Optional share description. (Default=None)

`--share_type <share-type>, --share-type <share-type>`

  Optional share type assigned to share. (Default=None)

`--driver_options [<key=value> [<key=value> ...]], --driver-options [<key=value> [<key=value> ...]]`

  Driver option key=value pairs (Optional, Default=None).

`--public`

  Level of visibility for share. Defines whether other tenants are able to see it or not. Available only for microversion >= 2.8.

### manila message-delete

    usage: manila message-delete <message> [<message> ...]

Remove one or more messages.

Positional arguments:

`<message>`

  ID of the message(s).

### manila message-list

    usage: manila message-list [--resource_id <resource_id>]
                            [--resource_type <type>] [--action_id <id>]
                            [--detail_id <id>] [--request_id <request_id>]
                            [--level <level>] [--limit <limit>]
                            [--offset <offset>] [--sort-key <sort_key>]
                            [--sort-dir <sort_dir>] [--columns <columns>]
                            [--since <since>] [--before <before>]

Lists all messages.

Optional arguments:

`--resource_id <resource_id>, --resource-id <resource_id>, --resource <resource_id>`

  Filters results by a resource uuid. (Default=None).

`--resource_type <type>, --resource-type <type>`

  Filters results by a resource type. (Default=None). Example: “manila message-list –resource_type share”

`--action_id <id>, --action-id <id>, --action <id>`

  Filters results by action id. (Default=None).

`--detail_id <id>, --detail-id <id>, --detail <id>`

  Filters results by detail id. (Default=None).

`--request_id <request_id>, --request-id <request_id>, --request <request_id>`

  Filters results by request id. (Default=None).

`--level <level>, --message_level <level>, --message-level <level>`

  Filters results by the message level. (Default=None). Example: “manila message-list –level ERROR”.

`--limit <limit>`

  Maximum number of messages to return. (Default=None)

`--offset <offset>`

  Start position of message listing.

`--sort-key <sort_key>, --sort_key <sort_key>`

  Key to be sorted, available keys are (‘id’, ‘project_id’, ‘request_id’, ‘resource_type’, ‘action_id’, ‘detail_id’, ‘resource_id’, ‘message_level’, ‘expires_at’, ‘request_id’, ‘created_at’). (Default=desc).

`--sort-dir <sort_dir>, --sort_dir <sort_dir>`

  Sort direction, available values are (‘asc’, ‘desc’). OPTIONAL: Default=None.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “resource_id, user_message”.

`--since <since>`

  Return only user messages created since given date. The date format must be conforming to ISO8601. Available only for microversion >= 2.52.

`--before <before>`

  Return only user messages created before given date. The date format must be conforming to ISO8601. Available only for microversion >= 2.52.

### manila message-show

    usage: manila message-show <message>

Show details about a message.

Positional arguments:

`<message>`

  ID of the message.

### manila metadata

    usage: manila metadata <share> <action> <key=value> [<key=value> ...]

Set or delete metadata on a share.

Positional arguments:

`<share>`

  Name or ID of the share to update metadata on.

`<action>`

  Actions: ‘set’ or ‘unset’.

`<key=value>`

  Metadata to set or unset (key is only necessary on unset).

### manila metadata-show

    usage: manila metadata-show <share>

Show metadata of given share.

Positional arguments:

`<share>`

  Name or ID of the share.

### manila metadata-update-all

    usage: manila metadata-update-all <share> <key=value> [<key=value> ...]

Update all metadata of a share.

Positional arguments:

`<share>`

  Name or ID of the share to update metadata on.

`<key=value>`

  Metadata entry or entries to update.

### manila migration-cancel

    usage: manila migration-cancel <share>

Cancels migration of a given share when copying (Admin only, Experimental).

Positional arguments:

`<share>`

  Name or ID of share to cancel migration.

### manila migration-complete

    usage: manila migration-complete <share>

Completes migration for a given share (Admin only, Experimental).

Positional arguments:

`<share>`

  Name or ID of share to complete migration.

### manila migration-get-progress

    usage: manila migration-get-progress <share>

Gets migration progress of a given share when copying (Admin only, Experimental).

Positional arguments:

`<share>`

  Name or ID of the share to get share migration progress information.

### manila migration-start

    usage: manila migration-start [--force_host_assisted_migration <True|False>]
                                  --preserve-metadata <True|False>
                                  --preserve-snapshots <True|False> --writable
                                  <True|False> --nondisruptive <True|False>
                                  [--new_share_network <new_share_network>]
                                  [--new_share_type <new_share_type>]
                                  <share> <host@backend#pool>

Migrates share to a new host (Admin only, Experimental).

Positional arguments:

`<share>`

  Name or ID of share to migrate.

`<host@backend#pool>`

  Destination host where share will be migrated to. Use the format ‘host@backend#pool’.

Optional arguments:

`--force_host_assisted_migration <True|False>, --force-host-assisted-migration <True|False>`

  Enforces the use of the host-assisted migration approach, which bypasses driver optimizations. Default=False.

`--preserve-metadata <True|False>, --preserve_metadata <True|False>`

  Enforces migration to preserve all file metadata when moving its contents. If set to True, host-assisted migration will not be attempted.

`--preserve-snapshots <True|False>, --preserve_snapshots <True|False>`

  Enforces migration of the share snapshots to the destination. If set to True, host-assisted migration will not be attempted.

`--writable <True|False>`

  Enforces migration to keep the share writable while contents are being moved. If set to True, host-assisted migration will not be attempted.

`--nondisruptive <True|False>`

  Enforces migration to be nondisruptive. If set to True, host-assisted migration will not be attempted.

`--new_share_network <new_share_network>, --new-share-network <new_share_network>`

  Specify the new share network for the share. Do not specify this parameter if the migrating share has to be retained within its current share network.

`--new_share_type <new_share_type>, --new-share-type <new_share_type>`

  Specify the new share type for the share. Do not specify this parameter if the migrating share has to be retained with its current share type.

### manila pool-list

    usage: manila pool-list [--host <host>] [--backend <backend>] [--pool <pool>]
                            [--columns <columns>] [--detail]
                            [--share-type <share_type>]

List all backend storage pools known to the scheduler (Admin only).

Optional arguments:

`--host <host>`

  Filter results by host name. Regular expressions are supported.

`--backend <backend>`

  Filter results by backend name. Regular expressions are supported.

`--pool <pool>`

  Filter results by pool name. Regular expressions are supported.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “name,host”.

`--detail, --detailed`

  Show detailed information about pools. (Default=False)

`--share-type <share_type>, --share_type <share_type>, --share-type-id <share_type>, --share_type_id <share_type>`

  Filter results by share type name or ID. (Default=None)Available only for microversion >= 2.23.

### manila quota-class-show

    usage: manila quota-class-show <class>

List the quotas for a quota class.

Positional arguments:

`<class>`

  Name of quota class to list the quotas for.

### manila quota-class-update

    usage: manila quota-class-update [--shares <shares>] [--snapshots <snapshots>]
                                     [--gigabytes <gigabytes>]
                                     [--snapshot-gigabytes <snapshot_gigabytes>]
                                     [--share-networks <share-networks>]
                                     [--share-groups <share-groups>]
                                     [--share-group-snapshots <share-group-snapshots>]
                                     <class-name>

Update the quotas for a quota class (Admin only).

Positional arguments:

`<class-name>`

  Name of quota class to set the quotas for.

Optional arguments:

`--shares <shares>`

  New value for the “shares” quota.

`--snapshots <snapshots>`

  New value for the “snapshots” quota.

`--gigabytes <gigabytes>`

  New value for the “gigabytes” quota.

`--snapshot-gigabytes <snapshot_gigabytes>, --snapshot_gigabytes <snapshot_gigabytes>`

  New value for the “snapshot_gigabytes” quota.

`--share-networks <share-networks>, --share_networks <share-networks>`

  New value for the “share_networks” quota.

`--share-groups <share-groups>, --share_groups <share-groups>`

  New value for the “share_groups” quota.

`--share-group-snapshots <share-group-snapshots>, --share_group_snapshots <share-group-snapshots>`

  New value for the “share_group_snapshots” quota.

### manila quota-defaults

    usage: manila quota-defaults [--tenant <tenant-id>]

List the default quotas for a tenant.

Optional arguments:

`--tenant <tenant-id>`

  ID of tenant to list the default quotas for.

### manila quota-delete

    usage: manila quota-delete [--tenant <tenant-id>] [--user <user-id>]
                               [--share-type <share-type>]

Delete quota for a tenant/user. The quota will revert back to default (Admin only).

Optional arguments:

`--tenant <tenant-id>`

  ID of tenant to delete quota for.

`--user <user-id>`

  ID of user to delete quota for.

`--share-type <share-type>, --share_type <share-type>`

  UUID or name of a share type to set the quotas for. Optional. Mutually exclusive with ‘–user-id’. Available only for microversion >= 2.39

### manila quota-show

    usage: manila quota-show [--tenant <tenant-id>] [--user <user-id>]
                             [--share-type <share-type>] [--detail]

List the quotas for a tenant/user.

Optional arguments:

`--tenant <tenant-id>`

  ID of tenant to list the quotas for.

`--user <user-id>`

  ID of user to list the quotas for.

`--share-type <share-type>, --share_type <share-type>`

  UUID or name of a share type to set the quotas for. Optional. Mutually exclusive with ‘–user-id’. Available only for microversion >= 2.39

`--detail`

  Optional flag to indicate whether to show quota in detail. Default false, available only for microversion >= 2.25.

### manila quota-update

    usage: manila quota-update [--user <user-id>] [--shares <shares>]
                               [--snapshots <snapshots>] [--gigabytes <gigabytes>]
                               [--snapshot-gigabytes <snapshot_gigabytes>]
                               [--share-networks <share-networks>]
                               [--share-groups <share-groups>]
                               [--share-group-snapshots <share-group-snapshots>]
                               [--share-type <share-type>] [--force]
                               <tenant_id>

Update the quotas for a tenant/user (Admin only).

Positional arguments:

`<tenant_id>`

  UUID of tenant to set the quotas for.

Optional arguments:

`--user <user-id>`

  ID of user to set the quotas for.

`--shares <shares>`

  New value for the “shares” quota.

`--snapshots <snapshots>`

  New value for the “snapshots” quota.

`--gigabytes <gigabytes>`

  New value for the “gigabytes” quota.

`--snapshot-gigabytes <snapshot_gigabytes>, --snapshot_gigabytes <snapshot_gigabytes>`

  New value for the “snapshot_gigabytes” quota.

`--share-networks <share-networks>, --share_networks <share-networks>`

  New value for the “share_networks” quota.

`--share-groups <share-groups>, --share_groups <share-groups>`

  New value for the “share_groups” quota.

`--share-group-snapshots <share-group-snapshots>, --share_group_snapshots <share-group-snapshots>`

  New value for the “share_group_snapshots” quota.

`--share-type <share-type>, --share_type <share-type>`

  UUID or name of a share type to set the quotas for. Optional. Mutually exclusive with ‘–user-id’. Available only for microversion >= 2.39

`--force`

  Whether force update the quota even if the already used and reserved exceeds the new quota.

### manila rate-limits

    usage: manila rate-limits [--columns <columns>]

Print a list of rate limits for a user.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “verb,uri,value”.

### manila reset-state

    usage: manila reset-state [--state <state>] <share>

Explicitly update the state of a share (Admin only).

Positional arguments:

`<share>`

  Name or ID of the share to modify.

Optional arguments:

`--state <state>`

  Indicate which state to assign the share. Options include available, error, creating, deleting, error_deleting. If no state is provided, available will be used.

### manila reset-task-state

    usage: manila reset-task-state [--task-state <task_state>] <share>

Explicitly update the task state of a share (Admin only, Experimental).

Positional arguments:

`<share>`

  Name or ID of the share to modify.

Optional arguments:

`--task-state <task_state>, --task_state <task_state>, --state <task_state>`

  Indicate which task state to assign the share. Options include migration_starting, migration_in_progress, migration_completing, migration_success, migration_error, migration_cancelled, migration_driver_in_progress, migration_driver_phase1_done, data_copying_starting, data_copying_in_progress, data_copying_completing, data_copying_completed, data_copying_cancelled, data_copying_error. If no value is provided, None will be used.

### manila revert-to-snapshot

    usage: manila revert-to-snapshot <snapshot>

Revert a share to the specified snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot to restore. The snapshot must be the most recent one known to manila.

### manila security-service-create

    usage: manila security-service-create [--dns-ip <dns_ip>] [--server <server>]
                                          [--domain <domain>] [--user <user>]
                                          [--password <password>] [--name <name>]
                                          [--description <description>]
                                          <type>

Create security service used by tenant.

Positional arguments:

`<type>`

  Security service type: ‘ldap’, ‘kerberos’ or ‘active_directory’.

Optional arguments:

`--dns-ip <dns_ip>`

  DNS IP address used inside tenant’s network.

`--server <server>`

  Security service IP address or hostname.

`--domain <domain>`

  Security service domain.

`--user <user>`

  Security service user or group used by tenant.

`--password <password>`

  Password used by user.

`--name <name>`

  Security service name.

`--description <description>`

  Security service description.

### manila security-service-delete

    usage: manila security-service-delete <security-service>
                                          [<security-service> ...]

Delete one or more security services.

Positional arguments:

`<security-service>`

  Name or ID of the security service(s) to delete.

### manila security-service-list

    usage: manila security-service-list [--all-tenants [<0|1>]]
                                        [--share-network <share_network>]
                                        [--status <status>] [--name <name>]
                                        [--type <type>] [--user <user>]
                                        [--dns-ip <dns_ip>] [--server <server>]
                                        [--domain <domain>] [--detailed [<0|1>]]
                                        [--offset <offset>] [--limit <limit>]
                                        [--columns <columns>]

Get a list of security services.

Optional arguments:

`--all-tenants [<0|1>]`

  Display information from all tenants (Admin only).

`--share-network <share_network>, --share_network <share_network>`

  Filter results by share network id or name.

`--status <status>`

  Filter results by status.

`--name <name>`

  Filter results by name.

`--type <type>`

  Filter results by type.

`--user <user>`

  Filter results by user or group used by tenant.

`--dns-ip <dns_ip>, --dns_ip <dns_ip>`

  Filter results by DNS IP address used inside tenant’s network.

`--server <server>`

  Filter results by security service IP address or hostname.

`--domain <domain>`

  Filter results by domain.

`--detailed [<0|1>]`

  Show detailed information about filtered security services.

`--offset <offset>`

  Start position of security services listing.

`--limit <limit>`

  Number of security services to return per request.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “name,type”.

### manila security-service-show

    usage: manila security-service-show <security-service>

Show security service.

Positional arguments:

`<security-service>`

  Security service name or ID to show.

### manila security-service-update

    usage: manila security-service-update [--dns-ip <dns-ip>] [--server <server>]
                                          [--domain <domain>] [--user <user>]
                                          [--password <password>] [--name <name>]
                                          [--description <description>]
                                          <security-service>

Update security service.

Positional arguments:

`<security-service>`

  Security service name or ID to update.

Optional arguments:

`--dns-ip <dns-ip>`

  DNS IP address used inside tenant’s network.

`--server <server>`

  Security service IP address or hostname.

`--domain <domain>`

  Security service domain.

`--user <user>`

  Security service user or group used by tenant.

`--password <password>`

  Password used by user.

`--name <name>`

  Security service name.

`--description <description>`

  Security service description.

### manila service-disable

    usage: manila service-disable <hostname> <binary>

Disables ‘manila-share’ or ‘manila-scheduler’ services (Admin only).

Positional arguments:

`<hostname>`

  Host name as ‘example_host@example_backend’.

`<binary>`

  Service binary, could be ‘manila-share’ or ‘manila-scheduler’.

### manila service-enable

    usage: manila service-enable <hostname> <binary>

Enables ‘manila-share’ or ‘manila-scheduler’ services (Admin only).

Positional arguments:

`<hostname>`

  Host name as ‘example_host@example_backend’.

`<binary>`

  Service binary, could be ‘manila-share’ or ‘manila-scheduler’.

### manila service-list

    usage: manila service-list [--host <hostname>] [--binary <binary>]
                               [--status <status>] [--state <state>]
                               [--zone <zone>] [--columns <columns>]

List all services (Admin only).

Optional arguments:

`--host <hostname>`

  Name of host.

`--binary <binary>`

  Service binary.

`--status <status>`

  Filter results by status.

`--state <state>`

  Filter results by state.

`--zone <zone>`

  Availability zone.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,host”.

### manila share-export-location-list

    usage: manila share-export-location-list [--columns <columns>] <share>

List export locations of a given share.

Positional arguments:

`<share>`

  Name or ID of the share.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,host,status”.

### manila share-export-location-show

    usage: manila share-export-location-show <share> <export_location>

Show export location of the share.

Positional arguments:

`<share>`

  Name or ID of the share.

`<export_location>`

  ID of the share export location.

### manila share-group-create

    usage: manila share-group-create [--name <name>] [--description <description>]
                                     [--share-types <share_types>]
                                     [--share-group-type <share_group_type>]
                                     [--share-network <share_network>]
                                     [--source-share-group-snapshot <source_share_group_snapshot>]
                                     [--availability-zone <availability-zone>]

Creates a new share group (Experimental).

Optional arguments:

`--name <name>`

  Optional share group name. (Default=None)

`--description <description>`

  Optional share group description. (Default=None)

`--share-types <share_types>, --share_types <share_types>`

  Comma-separated list of share types. (Default=None)

`--share-group-type <share_group_type>, --share_group_type <share_group_type>, --type <share_group_type>`

  Share group type name or ID of the share group to be created. (Default=None)

`--share-network <share_network>, --share_network <share_network>`

  Specify share network name or id.

`--source-share-group-snapshot <source_share_group_snapshot>, --source_share_group_snapshot <source_share_group_snapshot>`

  Optional share group snapshot name or ID to create the share group from. (Default=None)

`--availability-zone <availability-zone>, --availability_zone <availability-zone>, --az <availability-zone>`

  Optional availability zone in which group should be created. (Default=None)

### manila share-group-delete

    usage: manila share-group-delete [--force] <share_group> [<share_group> ...]

Remove one or more share groups (Experimental).

Positional arguments:

`<share_group>`

  Name or ID of the share_group(s).

Optional arguments:

`--force`

  Attempt to force delete the share group (Default=False) (Admin only).

### manila share-group-list

    usage: manila share-group-list [--all-tenants [<0|1>]] [--name <name>]
                                   [--status <status>]
                                   [--share-server-id <share_server_id>]
                                   [--share-group-type <share_group_type>]
                                   [--snapshot <snapshot>] [--host <host>]
                                   [--share-network <share_network>]
                                   [--project-id <project_id>] [--limit <limit>]
                                   [--offset <offset>] [--sort-key <sort_key>]
                                   [--sort-dir <sort_dir>] [--columns <columns>]

List share groups with filters (Experimental).

Optional arguments:

`--all-tenants [<0|1>]`

  Display information from all tenants (Admin only).

`--name <name>`

  Filter results by name.

`--status <status>`

  Filter results by status.

`--share-server-id <share_server_id>, --share-server_id <share_server_id>, --share_server-id <share_server_id>, --share_server_id <share_server_id>`

  Filter results by share server ID (Admin only).

`--share-group-type <share_group_type>, --share-group-type-id <share_group_type>, --share_group_type <share_group_type>, --share_group_type_id <share_group_type>`

  Filter results by a share group type ID or name that was used for share group creation.

`--snapshot <snapshot>`

  Filter results by share group snapshot name or ID that was used to create the share group.

`--host <host>`

  Filter results by host.

`--share-network <share_network>, --share_network <share_network>`

  Filter results by share-network name or ID.

`--project-id <project_id>, --project_id <project_id>`

  Filter results by project ID. Useful with set key ‘–all-tenants’.

`--limit <limit>`

  Maximum number of share groups to return. (Default=None)

`--offset <offset>`

  Start position of share group listing.

`--sort-key <sort_key>, --sort_key <sort_key>`

  Key to be sorted, available keys are (‘id’, ‘name’, ‘status’, ‘host’, ‘user_id’, ‘project_id’, ‘created_at’, ‘availability_zone’, ‘share_network’, ‘share_network_id’, ‘share_group_type’, ‘share_group_type_id’, ‘source_share_group_snapshot_id’). Default=None.

`--sort-dir <sort_dir>, --sort_dir <sort_dir>`

  Sort direction, available values are (‘asc’, ‘desc’). OPTIONAL: Default=None.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila share-group-reset-state

    usage: manila share-group-reset-state [--state <state>] <share_group>

Explicitly update the state of a share group (Admin only, Experimental).

Positional arguments:

`<share_group>`

  Name or ID of the share group to modify.

Optional arguments:

`--state <state>`

  Indicate which state to assign the share group. Options include available, error, creating, deleting, error_deleting. If no state is provided, available will be used.

### manila share-group-show

    usage: manila share-group-show <share_group>

Show details about a share group (Experimental).

Positional arguments:

`<share_group>`

  Name or ID of the share group.

### manila share-group-snapshot-create

    usage: manila share-group-snapshot-create [--name <name>]
                                              [--description <description>]
                                              <share_group>

Creates a new share group snapshot (Experimental).

Positional arguments:

`<share_group>`

  Name or ID of the share group.

Optional arguments:

`--name <name>`

  Optional share group snapshot name. (Default=None)

`--description <description>`

  Optional share group snapshot description. (Default=None)

### manila share-group-snapshot-delete

    usage: manila share-group-snapshot-delete [--force]
                                              <share_group_snapshot>
                                              [<share_group_snapshot> ...]

Remove one or more share group snapshots (Experimental).

Positional arguments:

`<share_group_snapshot>`

  Name or ID of the share group snapshot(s) to delete.

Optional arguments:

`--force`

  Attempt to force delete the share group snapshot(s) (Default=False) (Admin only).

### manila share-group-snapshot-list

    usage: manila share-group-snapshot-list [--all-tenants [<0|1>]]
                                            [--name <name>] [--status <status>]
                                            [--share-group-id <share_group_id>]
                                            [--limit <limit>] [--offset <offset>]
                                            [--sort-key <sort_key>]
                                            [--sort-dir <sort_dir>]
                                            [--detailed DETAILED]
                                            [--columns <columns>]

List share group snapshots with filters (Experimental).

Optional arguments:

`--all-tenants [<0|1>]`

  Display information from all tenants (Admin only).

`--name <name>`

  Filter results by name.

`--status <status>`

  Filter results by status.

`--share-group-id <share_group_id>, --share_group_id <share_group_id>`

  Filter results by share group ID.

`--limit <limit>`

  Maximum number of share group snapshots to return. (Default=None)

`--offset <offset>`

  Start position of share group snapshot listing.

`--sort-key <sort_key>, --sort_key <sort_key>`

  Key to be sorted, available keys are (‘id’, ‘name’, ‘status’, ‘host’, ‘user_id’, ‘project_id’, ‘created_at’, ‘share_group_id’). Default=None.

`--sort-dir <sort_dir>, --sort_dir <sort_dir>`

  Sort direction, available values are (‘asc’, ‘desc’). OPTIONAL: Default=None.

`--detailed DETAILED`

  Show detailed information about share group snapshots.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila share-group-snapshot-list-members

    usage: manila share-group-snapshot-list-members [--columns <columns>]
                                                    <share_group_snapshot>

List members of a share group snapshot (Experimental).

Positional arguments:

`<share_group_snapshot>`

  Name or ID of the share group snapshot.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila share-group-snapshot-reset-state

    usage: manila share-group-snapshot-reset-state [--state <state>]
                                                   <share_group_snapshot>

Explicitly update the state of a share group snapshot (Admin only, Experimental).

Positional arguments:

`<share_group_snapshot>`

  Name or ID of the share group snapshot.

Optional arguments:

`--state <state>`

  Indicate which state to assign the share group snapshot. Options include available, error, creating, deleting, error_deleting. If no state is provided, available will be used.

### manila share-group-snapshot-show

    usage: manila share-group-snapshot-show <share_group_snapshot>

Show details about a share group snapshot (Experimental).

Positional arguments:

`<share_group_snapshot>`

  Name or ID of the share group snapshot.

### manila share-group-snapshot-update

    usage: manila share-group-snapshot-update [--name <name>]
                                              [--description <description>]
                                              <share_group_snapshot>

Update a share group snapshot (Experimental).

Positional arguments:

`<share_group_snapshot>`

  Name or ID of the share group snapshot to update.

Optional arguments:

`--name <name>`

  Optional new name for the share group snapshot. (Default=None)

`--description <description>`

  Optional share group snapshot description. (Default=None)

### manila share-group-type-access-add

    usage: manila share-group-type-access-add <share_group_type> <project_id>

Adds share group type access for the given project (Admin only).

Positional arguments:

`<share_group_type>`

  Share group type name or ID to add access for the given project.

`<project_id>`

  Project ID to add share group type access for.

### manila share-group-type-access-list

    usage: manila share-group-type-access-list <share_group_type>

Print access information about a share group type (Admin only).

Positional arguments:

`<share_group_type>`

  Filter results by share group type name or ID.

### manila share-group-type-access-remove

    usage: manila share-group-type-access-remove <share_group_type> <project_id>

Removes share group type access for the given project (Admin only).

Positional arguments:

`<share_group_type>`

  Share group type name or ID to remove access for the given project.

`<project_id>`

  Project ID to remove share group type access for.

### manila share-group-type-create

    usage: manila share-group-type-create [--is_public <is_public>]
                                          <name> <share_types>

Create a new share group type (Admin only).

Positional arguments:

`<name>`

  Name of the new share group type.

`<share_types>`

  Comma-separated list of share type names or IDs.

Optional arguments:

`--is_public <is_public>, --is-public <is_public>`

  Make type accessible to the public (default true).

### manila share-group-type-delete

    usage: manila share-group-type-delete <id>

Delete a specific share group type (Admin only).

Positional arguments:

`<id>`

  Name or ID of the share group type to delete.

### manila share-group-type-key

    usage: manila share-group-type-key <share_group_type> <action>
                                       [<key=value> [<key=value> ...]]

Set or unset group_spec for a share group type (Admin only).

Positional arguments:

`<share_group_type>`

  Name or ID of the share group type.

`<action>`

  Actions: ‘set’ or ‘unset’.

`<key=value>`

  Group specs to set or unset (key is only necessary on unset).

### manila share-group-type-list

    usage: manila share-group-type-list [--all] [--columns <columns>]

Print a list of available ‘share group types’.

Optional arguments:

`--all`

  Display all share group types (Admin only).

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila share-group-type-specs-list

    usage: manila share-group-type-specs-list [--columns <columns>]

Print a list of ‘share group types specs’ (Admin Only).

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila share-group-update

    usage: manila share-group-update [--name <name>] [--description <description>]
                                     <share_group>

Update a share group (Experimental).

Positional arguments:

`<share_group>`

  Name or ID of the share group to update.

Optional arguments:

`--name <name>`

  Optional new name for the share group. (Default=None)

`--description <description>`

  Optional share group description. (Default=None)

### manila share-instance-export-location-list

    usage: manila share-instance-export-location-list [--columns <columns>]
                                                      <instance>

List export locations of a given share instance.

Positional arguments:

`<instance>`

  Name or ID of the share instance.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,host,status”.

### manila share-instance-export-location-show

    usage: manila share-instance-export-location-show <instance> <export_location>

Show export location for the share instance.

Positional arguments:

`<instance>`

  Name or ID of the share instance.

`<export_location>`

  ID of the share instance export location.

### manila share-instance-force-delete

    usage: manila share-instance-force-delete <instance> [<instance> ...]

Force-delete the share instance, regardless of state (Admin only).

Positional arguments:

`<instance>`

  Name or ID of the instance(s) to force delete.

### manila share-instance-list

    usage: manila share-instance-list [--share-id <share_id>]
                                      [--columns <columns>]

List share instances (Admin only).

Optional arguments:

`--share-id <share_id>, --share_id <share_id>`

  Filter results by share ID.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,host,status”.

### manila share-instance-reset-state

    usage: manila share-instance-reset-state [--state <state>] <instance>

Explicitly update the state of a share instance (Admin only).

Positional arguments:

`<instance>`

  Name or ID of the share instance to modify.

Optional arguments:

`--state <state>`

  Indicate which state to assign the instance. Options include available, error, creating, deleting, error_deleting, migrating,migrating_to. If no state is provided, available will be used.

### manila share-instance-show

    usage: manila share-instance-show <instance>

Show details about a share instance (Admin only).

Positional arguments:

`<instance>`

  Name or ID of the share instance.

### manila share-network-create

    usage: manila share-network-create [--neutron-net-id <neutron-net-id>]
                                       [--neutron-subnet-id <neutron-subnet-id>]
                                       [--name <name>]
                                       [--description <description>]

Create description for network used by the tenant.

Optional arguments:

`--neutron-net-id <neutron-net-id>, --neutron-net_id <neutron-net-id>, --neutron_net_id <neutron-net-id>, --neutron_net-id <neutron-net-id>`

  Neutron network ID. Used to set up network for share servers.

`--neutron-subnet-id <neutron-subnet-id>, --neutron-subnet_id <neutron-subnet-id>, --neutron_subnet_id <neutron-subnet-id>, --neutron_subnet-id <neutron-subnet-id>`

  Neutron subnet ID. Used to set up network for share servers. This subnet should belong to specified neutron network.

`--name <name>`

  Share network name.

`--description <description>`

  Share network description.

### manila share-network-delete

    usage: manila share-network-delete <share-network> [<share-network> ...]

Delete one or more share networks.

Positional arguments:

`<share-network>`

  Name or ID of share network(s) to be deleted.

### manila share-network-list

    usage: manila share-network-list [--all-tenants [<0|1>]]
                                     [--project-id <project_id>] [--name <name>]
                                     [--created-since <created_since>]
                                     [--created-before <created_before>]
                                     [--security-service <security_service>]
                                     [--neutron-net-id <neutron_net_id>]
                                     [--neutron-subnet-id <neutron_subnet_id>]
                                     [--network-type <network_type>]
                                     [--segmentation-id <segmentation_id>]
                                     [--cidr <cidr>] [--ip-version <ip_version>]
                                     [--offset <offset>] [--limit <limit>]
                                     [--columns <columns>]

Get a list of network info.

Optional arguments:

`--all-tenants [<0|1>]`

  Display information from all tenants (Admin only).

`--project-id <project_id>, --project_id <project_id>`

  Filter results by project ID.

`--name <name>`

  Filter results by name.

`--created-since <created_since>, --created_since <created_since>`

  Return only share networks created since given date. The date is in the format ‘yyyy-mm-dd’.

`--created-before <created_before>, --created_before <created_before>`

  Return only share networks created until given date. The date is in the format ‘yyyy-mm-dd’.

`--security-service <security_service>, --security_service <security_service>`

  Filter results by attached security service.

`--neutron-net-id <neutron_net_id>, --neutron_net_id <neutron_net_id>, --neutron_net-id <neutron_net_id>, --neutron-net_id <neutron_net_id>`

  Filter results by neutron net ID.

`--neutron-subnet-id <neutron_subnet_id>, --neutron_subnet_id <neutron_subnet_id>, --neutron-subnet_id <neutron_subnet_id>, --neutron_subnet-id <neutron_subnet_id>`

  Filter results by neutron subnet ID.

`--network-type <network_type>, --network_type <network_type>`

  Filter results by network type.

`--segmentation-id <segmentation_id>, --segmentation_id <segmentation_id>`

  Filter results by segmentation ID.

`--cidr <cidr>`

  Filter results by CIDR.

`--ip-version <ip_version>, --ip_version <ip_version>`

  Filter results by IP version.

`--offset <offset>`

  Start position of share networks listing.

`--limit <limit>`

  Number of share networks to return per request.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id”.

### manila share-network-security-service-add

    usage: manila share-network-security-service-add <share-network>
                                                     <security-service>

Associate security service with share network.

Positional arguments:

`<share-network>`

  Share network name or ID.

`<security-service>`

  Security service name or ID to associate with.

### manila share-network-security-service-list

    usage: manila share-network-security-service-list [--columns <columns>]
                                                      <share-network>

Get list of security services associated with a given share network.

Positional arguments:

`<share-network>`

  Share network name or ID.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila share-network-security-service-remove

    usage: manila share-network-security-service-remove <share-network>
                                                        <security-service>

Dissociate security service from share network.

Positional arguments:

`<share-network>`

  Share network name or ID.

`<security-service>`

  Security service name or ID to dissociate.

### manila share-network-show

    usage: manila share-network-show <share-network>

Get a description for network used by the tenant.

Positional arguments:

`<share-network>`

  Name or ID of the share network to show.

### manila share-network-update

    usage: manila share-network-update [--neutron-net-id <neutron-net-id>]
                                       [--neutron-subnet-id <neutron-subnet-id>]
                                       [--name <name>]
                                       [--description <description>]
                                       <share-network>

Update share network data.

Positional arguments:

`<share-network>`

  Name or ID of share network to update.

Optional arguments:

`--neutron-net-id <neutron-net-id>, --neutron-net_id <neutron-net-id>, --neutron_net_id <neutron-net-id>, --neutron_net-id <neutron-net-id>`

  Neutron network ID. Used to set up network for share servers. This option is deprecated and will be rejected in newer releases of OpenStack Manila.

`--neutron-subnet-id <neutron-subnet-id>, --neutron-subnet_id <neutron-subnet-id>, --neutron_subnet_id <neutron-subnet-id>, --neutron_subnet-id <neutron-subnet-id>`

  Neutron subnet ID. Used to set up network for share servers. This subnet should belong to specified neutron network.

`--name <name>`

  Share network name.

`--description <description>`

  Share network description.

### manila share-replica-create

    usage: manila share-replica-create [--availability-zone <availability-zone>]
                                       [--share-network <network-info>]
                                       <share>

Create a share replica (Experimental).

Positional arguments:

`<share>`

  Name or ID of the share to replicate.

Optional arguments:

`--availability-zone <availability-zone>, --availability_zone <availability-zone>, --az <availability-zone>`

  Optional Availability zone in which replica should be created.

`--share-network <network-info>, --share_network <network-info>`

  Optional network info ID or name.

### manila share-replica-delete

    usage: manila share-replica-delete [--force] <replica> [<replica> ...]

Remove one or more share replicas (Experimental).

Positional arguments:

`<replica>`

  ID of the share replica.

Optional arguments:

`--force`

  Attempt to force deletion of a replica on its backend. Using this option will purge the replica from Manila even if it is not cleaned up on the backend. Defaults to False.

### manila share-replica-list

    usage: manila share-replica-list [--share-id <share_id>] [--columns <columns>]

List share replicas (Experimental).

Optional arguments:

`--share-id <share_id>, --share_id <share_id>, --si <share_id>`

  List replicas belonging to share.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “replica_state,id”.

### manila share-replica-promote

    usage: manila share-replica-promote <replica>

Promote specified replica to ‘active’ replica_state (Experimental).

Positional arguments:

`<replica>`

  ID of the share replica.

### manila share-replica-reset-replica-state

    usage: manila share-replica-reset-replica-state
                                                    [--replica-state <replica_state>]
                                                    <replica>

Explicitly update the ‘replica_state’ of a share replica (Experimental).

Positional arguments:

`<replica>`

  ID of the share replica to modify.

Optional arguments:

`--replica-state <replica_state>, --replica_state <replica_state>, --state <replica_state>`

  Indicate which replica_state to assign the replica. Options include in_sync, out_of_sync, active, error. If no state is provided, out_of_sync will be used.

### manila share-replica-reset-state

    usage: manila share-replica-reset-state [--state <state>] <replica>

Explicitly update the ‘status’ of a share replica (Experimental).

Positional arguments:

`<replica>`

  ID of the share replica to modify.

Optional arguments:

`--state <state>`

  Indicate which state to assign the replica. Options include available, error, creating, deleting, error_deleting. If no state is provided, available will be used.

### manila share-replica-resync

    usage: manila share-replica-resync <replica>

Attempt to update the share replica with its ‘active’ mirror (Experimental).

Positional arguments:

`<replica>`

  ID of the share replica to resync.

### manila share-replica-show

    usage: manila share-replica-show <replica>

Show details about a replica (Experimental).

Positional arguments:

`<replica>`

  ID of the share replica.

### manila share-server-delete

    usage: manila share-server-delete <id> [<id> ...]

Delete one or more share servers (Admin only).

Positional arguments:

`<id>`

  ID of the share server(s) to delete.

### manila share-server-details

    usage: manila share-server-details <id>

Show share server details (Admin only).

Positional arguments:

`<id>`

  ID of share server.

### manila share-server-list

    usage: manila share-server-list [--host <hostname>] [--status <status>]
                                    [--share-network <share_network>]
                                    [--project-id <project_id>]
                                    [--columns <columns>]

List all share servers (Admin only).

Optional arguments:

`--host <hostname>`

  Filter results by name of host.

`--status <status>`

  Filter results by status.

`--share-network <share_network>`

  Filter results by share network.

`--project-id <project_id>`

  Filter results by project ID.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,host,status”.

### manila share-server-show

    usage: manila share-server-show <id>

Show share server info (Admin only).

Positional arguments:

`<id>`

  ID of share server.

### manila show

    usage: manila show <share>

Show details about a NAS share.

Positional arguments:

`<share>`

  Name or ID of the NAS share.

### manila shrink

    usage: manila shrink <share> <new_size>

Decreases the size of an existing share.

Positional arguments:

`<share>`

  Name or ID of share to shrink.

`<new_size>`

  New size of share, in GiBs.

### manila snapshot-access-allow

    usage: manila snapshot-access-allow <snapshot> <access_type> <access_to>

Allow read only access to a snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the share snapshot to allow access to.

`<access_type>`

  Access rule type (only “ip”, “user”(user or group), “cert” or “cephx” are supported).

`<access_to>`

  Value that defines access.

### manila snapshot-access-deny

    usage: manila snapshot-access-deny <snapshot> <id> [<id> ...]

Deny access to a snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the share snapshot to deny access to.

`<id>`

  ID(s) of the access rule(s) to be deleted.

### manila snapshot-access-list

    usage: manila snapshot-access-list [--columns <columns>] <snapshot>

Show access list for a snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the share snapshot to list access of.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “access_type,access_to”.

### manila snapshot-create

    usage: manila snapshot-create [--force <True|False>] [--name <name>]
                                  [--description <description>]
                                  <share>

Add a new snapshot.

Positional arguments:

`<share>`

  Name or ID of the share to snapshot.

Optional arguments:

`--force <True|False>`

  Optional flag to indicate whether to snapshot a share even if it’s busy. (Default=False)

`--name <name>`

  Optional snapshot name. (Default=None)

`--description <description>`

  Optional snapshot description. (Default=None)

### manila snapshot-delete

    usage: manila snapshot-delete <snapshot> [<snapshot> ...]

Remove one or more snapshots.

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot(s) to delete.

### manila snapshot-export-location-list

    usage: manila snapshot-export-location-list [--columns <columns>] <snapshot>

List export locations of a given snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,path”.

### manila snapshot-export-location-show

    usage: manila snapshot-export-location-show <snapshot> <export_location>

Show export location of the share snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot.

`<export_location>`

  ID of the share snapshot export location.

### manila snapshot-force-delete

    usage: manila snapshot-force-delete <snapshot> [<snapshot> ...]

Attempt force-deletion of one or more snapshots. Regardless of the state (Admin only).

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot(s) to force delete.

### manila snapshot-instance-export-location-list

    usage: manila snapshot-instance-export-location-list [--columns <columns>]
                                                         <instance>

List export locations of a given snapshot instance.

Positional arguments:

`<instance>`

  Name or ID of the snapshot instance.

Optional arguments:

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,path,is_admin_only”.

### manila snapshot-instance-export-location-show

    usage: manila snapshot-instance-export-location-show <snapshot_instance>
                                                         <export_location>

Show export location of the share instance snapshot.

Positional arguments:

`<snapshot_instance>`

  ID of the share snapshot instance.

`<export_location>`

  ID of the share snapshot instance export location.

### manila snapshot-instance-list

    usage: manila snapshot-instance-list [--snapshot <snapshot>]
                                         [--columns <columns>]
                                         [--detailed <detailed>]

List share snapshot instances.

Optional arguments:

`--snapshot <snapshot>`

  Filter results by share snapshot ID.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id”.

`--detailed <detailed>`

  Show detailed information about snapshot instances. (Default=False)

### manila snapshot-instance-reset-state

    usage: manila snapshot-instance-reset-state [--state <state>]
                                                <snapshot_instance>

Explicitly update the state of a share snapshot instance.

Positional arguments:

`<snapshot_instance>`

  ID of the snapshot instance to modify.

Optional arguments:

`--state <state>`

  Indicate which state to assign the snapshot instance. Options include available, error, creating, deleting, error_deleting. If no state is provided, available will be used.

### manila snapshot-instance-show

    usage: manila snapshot-instance-show <snapshot_instance>

Show details about a share snapshot instance.

Positional arguments:

`<snapshot_instance>`

  ID of the share snapshot instance.

### manila snapshot-list

    usage: manila snapshot-list [--all-tenants [<0|1>]] [--name <name>]
                                [--status <status>] [--share-id <share_id>]
                                [--usage [any|used|unused]] [--limit <limit>]
                                [--offset <offset>] [--sort-key <sort_key>]
                                [--sort-dir <sort_dir>] [--columns <columns>]

List all the snapshots.

Optional arguments:

`--all-tenants [<0|1>]`

  Display information from all tenants (Admin only).

`--name <name>`

  Filter results by name.

`--status <status>`

  Filter results by status.

`--share-id <share_id>, --share_id <share_id>`

  Filter results by source share ID.

`--usage [any|used|unused]`

  Either filter or not snapshots by its usage. OPTIONAL: Default=any.

`--limit <limit>`

  Maximum number of share snapshots to return. OPTIONAL: Default=None.

`--offset <offset>`

  Set offset to define start point of share snapshots listing. OPTIONAL: Default=None.

`--sort-key <sort_key>, --sort_key <sort_key>`

  Key to be sorted, available keys are (‘id’, ‘status’, ‘size’, ‘share_id’, ‘user_id’, ‘project_id’, ‘progress’, ‘name’, ‘display_name’). Default=None.

`--sort-dir <sort_dir>, --sort_dir <sort_dir>`

  Sort direction, available values are (‘asc’, ‘desc’). OPTIONAL: Default=None.

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila snapshot-manage

    usage: manila snapshot-manage [--name <name>] [--description <description>]
                                  [--driver_options [<key=value> [<key=value> ...]]]
                                  <share> <provider_location>

Manage share snapshot not handled by Manila (Admin only).

Positional arguments:

`<share>`

  Name or ID of the share.

`<provider_location>`

  Provider location of the snapshot on the backend.

Optional arguments:

`--name <name>`

  Optional snapshot name (Default=None).

`--description <description>`

  Optional snapshot description (Default=None).

`--driver_options [<key=value> [<key=value> ...]], --driver-options [<key=value> [<key=value> ...]]`

  Optional driver options as key=value pairs (Default=None).

### manila snapshot-rename

    usage: manila snapshot-rename [--description <description>]
                                  <snapshot> [<name>]

Rename a snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot to rename.

`<name>`

  New name for the snapshot.

Optional arguments:

`--description <description>`

  Optional snapshot description. (Default=None)

### manila snapshot-reset-state

    usage: manila snapshot-reset-state [--state <state>] <snapshot>

Explicitly update the state of a snapshot (Admin only).

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot to modify.

Optional arguments:

`--state <state>`

  Indicate which state to assign the snapshot. Options include available, error, creating, deleting, error_deleting. If no state is provided, available will be used.

### manila snapshot-show

    usage: manila snapshot-show <snapshot>

Show details about a snapshot.

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot.

### manila snapshot-unmanage

    usage: manila snapshot-unmanage <snapshot> [<snapshot> ...]

Unmanage one or more share snapshots (Admin only).

Positional arguments:

`<snapshot>`

  Name or ID of the snapshot(s).

### manila type-access-add

    usage: manila type-access-add <share_type> <project_id>

Adds share type access for the given project (Admin only).

Positional arguments:

`<share_type>`

  Share type name or ID to add access for the given project.

`<project_id>`

  Project ID to add share type access for.

### manila type-access-list

    usage: manila type-access-list <share_type>

Print access information about the given share type (Admin only).

Positional arguments:

`<share_type>`

  Filter results by share type name or ID.

### manila type-access-remove

    usage: manila type-access-remove <share_type> <project_id>

Removes share type access for the given project (Admin only).

Positional arguments:

`<share_type>`

  Share type name or ID to remove access for the given project.

`<project_id>`

  Project ID to remove share type access for.

### manila type-create

    usage: manila type-create [--snapshot_support <snapshot_support>]
                              [--create_share_from_snapshot_support <create_share_from_snapshot_support>]
                              [--revert_to_snapshot_support <revert_to_snapshot_support>]
                              [--mount_snapshot_support <mount_snapshot_support>]
                              [--extra-specs [<key=value> [<key=value> ...]]]
                              [--is_public <is_public>]
                              <name> <spec_driver_handles_share_servers>

Create a new share type (Admin only).

Positional arguments:

`<name>`

  Name of the new share type.

`<spec_driver_handles_share_servers>`

  Required extra specification. Valid values are ‘true’/’1’ and ‘false’/’0’.

Optional arguments:

`--snapshot_support <snapshot_support>, --snapshot-support <snapshot_support>`

  Boolean extra spec used for filtering of back ends by their capability to create share snapshots.

`--create_share_from_snapshot_support <create_share_from_snapshot_support>, --create-share-from-snapshot-support <create_share_from_snapshot_support>`

  Boolean extra spec used for filtering of back ends by their capability to create shares from snapshots.

`--revert_to_snapshot_support <revert_to_snapshot_support>, --revert-to-snapshot-support <revert_to_snapshot_support>`

  Boolean extra spec used for filtering of back ends by their capability to revert shares to snapshots. (Default is False).

`--mount_snapshot_support <mount_snapshot_support>, --mount-snapshot-support <mount_snapshot_support>`

  Boolean extra spec used for filtering of back ends by their capability to mount share snapshots. (Default is False).

`--extra-specs [<key=value> [<key=value> ...]], --extra_specs [<key=value> [<key=value> ...]]`

  Extra specs key and value of share type that will be used for share type creation. OPTIONAL: Default=None. example –extra-specs thin_provisioning=’<is> True’, replication_type=readable.

`--is_public <is_public>, --is-public <is_public>`

  Make type accessible to the public (default true).

### manila type-delete

    usage: manila type-delete <id> [<id> ...]

Delete one or more specific share types (Admin only).

Positional arguments:

`<id>`

  Name or ID of the share type(s) to delete.

### manila type-key

    usage: manila type-key <stype> <action> [<key=value> [<key=value> ...]]

Set or unset extra_spec for a share type (Admin only).

Positional arguments:

`<stype>`

  Name or ID of the share type.

`<action>`

  Actions: ‘set’ or ‘unset’.

`<key=value>`

  Extra_specs to set or unset (key is only necessary on unset).

### manila type-list

    usage: manila type-list [--all] [--columns <columns>]

Print a list of available ‘share types’.

Optional arguments:

`--all`

  Display all share types (Admin only).

`--columns <columns>`

  Comma separated list of columns to be displayed example –columns “id,name”.

### manila unmanage

    usage: manila unmanage <share>

Unmanage share (Admin only).

Positional arguments:

`<share>`

  Name or ID of the share(s).

### manila update

    usage: manila update [--name <name>] [--description <description>]
                         [--is-public <is_public>]
                         <share>

Rename a share.

Positional arguments:

`<share>`

  Name or ID of the share to rename.

Optional arguments:

`--name <name>`

  New name for the share.

`--description <description>`

  Optional share description. (Default=None)

`--is-public <is_public>, --is_public <is_public>`

  Public share is visible for all tenants.

this page last updated: 2026-04-22 07:00:00

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug